> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a transformation

> Updates a transformation by its ID.

**Required ACL:** `addObject`, `deleteIndex`, `editSettings`


## OpenAPI

````yaml specs/ingestion.yml put /1/transformations/{transformationID}
openapi: 3.1.0
info:
  title: Ingestion API
  summary: >-
    The Ingestion API lets you connect third-party services and platforms with
    Algolia and schedule tasks to ingest your data
  description: >
    The Ingestion API powers the no-code [data
    connectors](https://dashboard.algolia.com/connectors).


    ## Base URLs


    Base URLs for the Ingestion API:


    - `https://data.us.algolia.com`

    - `https://data.eu.algolia.com`


    Use the URL that matches your [analytics
    region](https://dashboard.algolia.com/account/infrastructure/analytics).


    **All requests must use HTTPS.**


    ## Authentication


    Add these headers to authenticate requests:


    - `x-algolia-application-id`. Your Algolia application ID.

    - `x-algolia-api-key`. An API key with the necessary permissions to make the
    request.
      The required access control list (ACL) to make a request is listed in each endpoint's reference.

    You can find your application ID and API key in the [Algolia
    dashboard](https://dashboard.algolia.com/account/api-keys).


    ## Request format


    Request bodies must be JSON objects.


    ## Response status and errors


    Response bodies are JSON objects.


    Successful responses return `2xx` statuses. Client errors return `4xx`
    statuses. Server errors return `5xx` statuses.

    Error responses have a `message` property with more information.


    ## Version


    The current version of the Ingestion API is version 1, indicated by the
    `/1/` in each endpoint's URL.
  version: 1.0.0
servers:
  - url: https://data.{region}.algolia.com
    variables:
      region:
        description: The region where your Algolia application is hosted.
        enum:
          - eu
          - us
        default: us
security:
  - appId: []
    apiKey: []
tags:
  - name: authentications
    x-displayName: Authentications
    description: >-
      Authentication resources describe how to connect to a source or
      destination.
  - name: destinations
    x-displayName: Destinations
    description: >
      Destinations are Algolia products or features where your data should be
      used, such as a search index or events.

      Algolia destinations require authentication with the `algolia` type.

      You can reference authentications by their ID when creating destinations.
  - name: observability
    x-displayName: Observability
    description: >-
      Check the status and details of your task runs. A run is one instance of a
      configured task.
  - name: sources
    x-displayName: Sources
    description: >
      Sources are third-party platforms or services from where you want to
      ingest your data.

      Sources may require authentication. To interact with such sources, you can
      reference an authentication resource by its ID.
  - name: tasks
    x-displayName: Tasks
    description: >
      Tasks contain information how your data should be read from a source and
      stored in a destination.

      Tasks have _triggers_ which determine when the task should run.
  - name: transformations
    x-displayName: Transformations
    description: >
      Transformations let you transform a record before it gets indexed in
      Algolia.
paths:
  /1/transformations/{transformationID}:
    put:
      tags:
        - transformations
      summary: Update a transformation
      description: Updates a transformation by its ID.
      operationId: updateTransformation
      parameters:
        - $ref: '#/components/parameters/pathTransformationID'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TransformationCreate'
        required: true
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransformationUpdateResponse'
        '400':
          $ref: '#/components/responses/BadRequest'
      x-codeSamples:
        - lang: csharp
          label: C#
          source: |-
            // Initialize the client
            var client = new IngestionClient(
              new IngestionConfig("ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY", "ALGOLIA_APPLICATION_REGION")
            );

            // Call the API
            var response = await client.UpdateTransformationAsync(
              "6c02aeb1-775e-418e-870b-1faccd4b2c0f",
              new TransformationCreate
              {
                Input = new TransformationInput(new TransformationCode { Code = "foo" }),
                Type = Enum.Parse<TransformationType>("Code"),
                Name = "bar",
                Description = "baz",
              }
            );

            // print the response
            Console.WriteLine(response);
        - lang: dart
          label: Dart
          source: |-
            // Initialize the client
            final client = IngestionClient(
                appId: 'ALGOLIA_APPLICATION_ID',
                apiKey: 'ALGOLIA_API_KEY',
                region: 'ALGOLIA_APPLICATION_REGION');

            // Call the API
            final response = await client.updateTransformation(
              transformationID: "6c02aeb1-775e-418e-870b-1faccd4b2c0f",
              transformationCreate: TransformationCreate(
                input: TransformationCode(
                  code: "foo",
                ),
                type: TransformationType.fromJson("code"),
                name: "bar",
                description: "baz",
              ),
            );

            // print the response
            print(response);
        - lang: go
          label: Go
          source: >-
            // Initialize the client with your application region, eg.
            ingestion.ALGOLIA_APPLICATION_REGION

            client, err := ingestion.NewClient("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY", ingestion.US)

            if err != nil {
              // The client can fail to initialize if you pass an invalid parameter.
              panic(err)
            }


            // Call the API

            response, err :=
            client.UpdateTransformation(client.NewApiUpdateTransformationRequest(
              "6c02aeb1-775e-418e-870b-1faccd4b2c0f",
              ingestion.NewEmptyTransformationCreate().SetInput(ingestion.TransformationCodeAsTransformationInput(
                ingestion.NewEmptyTransformationCode().
                  SetCode("foo"),
              )).SetType(ingestion.TransformationType("code")).SetName("bar").SetDescription("baz")))
            if err != nil {
              // handle the eventual error
              panic(err)
            }



            // print the response

            print(response)
        - lang: java
          label: Java
          source: >-
            // Initialize the client

            IngestionClient client = new
            IngestionClient("ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY",
            "ALGOLIA_APPLICATION_REGION");


            // Call the API

            TransformationUpdateResponse response = client.updateTransformation(
              "6c02aeb1-775e-418e-870b-1faccd4b2c0f",
              new TransformationCreate()
                .setInput(new TransformationCode().setCode("foo"))
                .setType(TransformationType.CODE)
                .setName("bar")
                .setDescription("baz")
            );


            // print the response

            System.out.println(response);
        - lang: javascript
          label: JavaScript
          source: >-
            // Initialize the client

            // Replace 'us' with your Algolia Application Region

            const client = algoliasearch('ALGOLIA_APPLICATION_ID',
            'ALGOLIA_API_KEY').initIngestion({ region: 'us' });


            // Call the API

            const response = await client.updateTransformation({
              transformationID: '6c02aeb1-775e-418e-870b-1faccd4b2c0f',
              transformationCreate: { input: { code: 'foo' }, type: 'code', name: 'bar', description: 'baz' },
            });



            // print the response

            console.log(response);
        - lang: kotlin
          label: Kotlin
          source: |-
            // Initialize the client
            val client =
              IngestionClient(
                appId = "ALGOLIA_APPLICATION_ID",
                apiKey = "ALGOLIA_API_KEY",
                region = "ALGOLIA_APPLICATION_REGION",
              )

            // Call the API
            var response =
              client.updateTransformation(
                transformationID = "6c02aeb1-775e-418e-870b-1faccd4b2c0f",
                transformationCreate =
                  TransformationCreate(
                    input = TransformationCode(code = "foo"),
                    type = TransformationType.entries.first { it.value == "code" },
                    name = "bar",
                    description = "baz",
                  ),
              )


            // print the response
            println(response)
        - lang: php
          label: PHP
          source: >-
            // Initialize the client

            $client = IngestionClient::create('ALGOLIA_APPLICATION_ID',
            'ALGOLIA_API_KEY', 'ALGOLIA_APPLICATION_REGION');


            // Call the API

            $response = $client->updateTransformation(
                '6c02aeb1-775e-418e-870b-1faccd4b2c0f',
                ['input' => ['code' => 'foo',
                ],
                    'type' => 'code',
                    'name' => 'bar',
                    'description' => 'baz',
                ],
            );



            // print the response

            var_dump($response);
        - lang: python
          label: Python
          source: >-
            # Initialize the client

            # In an asynchronous context, you can use IngestionClient instead,
            which exposes the exact same methods.

            client = IngestionClientSync(
                "ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY", "ALGOLIA_APPLICATION_REGION"
            )


            # Call the API

            response = client.update_transformation(
                transformation_id="6c02aeb1-775e-418e-870b-1faccd4b2c0f",
                transformation_create={
                    "input": {
                        "code": "foo",
                    },
                    "type": "code",
                    "name": "bar",
                    "description": "baz",
                },
            )



            # print the response

            print(response)
        - lang: ruby
          label: Ruby
          source: >-
            # Initialize the client

            client = Algolia::IngestionClient.create("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY", "ALGOLIA_APPLICATION_REGION")


            # Call the API

            response = client.update_transformation(
              "6c02aeb1-775e-418e-870b-1faccd4b2c0f",
              Algolia::Ingestion::TransformationCreate.new(
                input: Algolia::Ingestion::TransformationCode.new(code: "foo"),
                type: "code",
                name: "bar",
                description: "baz"
              )
            )



            # print the response

            puts(response)
        - lang: scala
          label: Scala
          source: |-
            // Initialize the client
            val client = IngestionClient(
              appId = "ALGOLIA_APPLICATION_ID",
              apiKey = "ALGOLIA_API_KEY",
              region = "ALGOLIA_APPLICATION_REGION"
            )

            // Call the API
            val response = Await.result(
              client.updateTransformation(
                transformationID = "6c02aeb1-775e-418e-870b-1faccd4b2c0f",
                transformationCreate = TransformationCreate(
                  input = Some(
                    TransformationCode(
                      code = "foo"
                    )
                  ),
                  `type` = Some(TransformationType.withName("code")),
                  name = "bar",
                  description = Some("baz")
                )
              ),
              Duration(100, "sec")
            )

            // print the response
            println(response)
        - lang: swift
          label: Swift
          source: >-
            // Initialize the client

            let client = try IngestionClient(appID: "ALGOLIA_APPLICATION_ID",
            apiKey: "ALGOLIA_API_KEY", region: .us)


            // Call the API

            let response = try await client.updateTransformation(
                transformationID: "6c02aeb1-775e-418e-870b-1faccd4b2c0f",
                transformationCreate: TransformationCreate(
                    name: "bar",
                    type: TransformationType.code,
                    input: TransformationInput.transformationCode(TransformationCode(code: "foo")),
                    description: "baz"
                )
            )


            // print the response

            print(response)
        - lang: cURL
          label: curl
          source: |-
            curl --request PUT \
              --url https://data.us.algolia.com/1/transformations/6c02aeb1-775e-418e-870b-1faccd4b2c0f \
              --header 'accept: application/json' \
              --header 'content-type: application/json' \
              --header 'x-algolia-api-key: ALGOLIA_API_KEY' \
              --header 'x-algolia-application-id: ALGOLIA_APPLICATION_ID' \
              --data '
            {
              "code": "lorem",
              "name": "lorem",
              "type": "code",
              "input": {
                "code": "lorem"
              },
              "description": "lorem",
              "authenticationIDs": [
                "6c02aeb1-775e-418e-870b-1faccd4b2c0f"
              ]
            }
            '
components:
  parameters:
    pathTransformationID:
      name: transformationID
      in: path
      required: true
      description: Unique identifier of a transformation.
      schema:
        $ref: '#/components/schemas/transformationID'
  schemas:
    TransformationCreate:
      type: object
      additionalProperties: false
      description: API request body for creating a transformation.
      properties:
        name:
          $ref: '#/components/schemas/Name'
        authenticationIDs:
          $ref: '#/components/schemas/AuthenticationIDs'
        code:
          $ref: '#/components/schemas/Code'
        description:
          $ref: '#/components/schemas/Description'
        input:
          $ref: '#/components/schemas/TransformationInput'
        type:
          $ref: '#/components/schemas/TransformationType'
      required:
        - name
    TransformationUpdateResponse:
      type: object
      description: API response for updating a transformation.
      additionalProperties: false
      properties:
        transformationID:
          $ref: '#/components/schemas/transformationID'
        updatedAt:
          $ref: '#/components/schemas/updatedAt'
      required:
        - transformationID
        - updatedAt
    transformationID:
      type: string
      description: Universally unique identifier (UUID) of a transformation.
      example: 6c02aeb1-775e-418e-870b-1faccd4b2c0f
    Name:
      type: string
      description: The uniquely identified name of your transformation.
    AuthenticationIDs:
      description: The authentications associated with the current transformation.
      type: array
      items:
        $ref: '#/components/schemas/authenticationID'
    Code:
      type: string
      deprecated: true
      description: >-
        It is deprecated. Use the `input` field with proper `type` instead to
        specify the transformation code.
    Description:
      type: string
      description: A descriptive name for your transformation of what it does.
    TransformationInput:
      description: >-
        The input for the transformation, which can be either code or a no-code
        configuration.
      oneOf:
        - $ref: '#/components/schemas/TransformationCode'
        - $ref: '#/components/schemas/TransformationNoCode'
    TransformationType:
      type: string
      description: The type of transformation, which can be either 'code' or 'noCode'.
      enum:
        - code
        - noCode
    updatedAt:
      type: string
      description: Date and time when the resource was last updated, in RFC 3339 format.
    ErrorBase:
      description: Error.
      type: object
      x-keep-model: true
      additionalProperties: true
      properties:
        message:
          type: string
          example: Invalid Application-Id or API-Key
    authenticationID:
      type: string
      description: Universally unique identifier (UUID) of an authentication resource.
      example: 6c02aeb1-775e-418e-870b-1faccd4b2c0f
    TransformationCode:
      title: Code
      type: object
      additionalProperties: false
      description: >-
        Input for a transformation that contains the source code of the
        transformation.
      properties:
        code:
          type: string
          description: The source code of the transformation.
      required:
        - code
    TransformationNoCode:
      title: No-code
      type: object
      additionalProperties: false
      description: Input for a no-code transformation that contains a series of steps.
      properties:
        steps:
          type: array
          items:
            $ref: '#/components/schemas/TransformationNoCodeStep'
      required:
        - steps
    TransformationNoCodeStep:
      type: object
      description: A step in a no-code transformation.
  responses:
    BadRequest:
      description: Bad request or request arguments.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorBase'
  securitySchemes:
    appId:
      type: apiKey
      in: header
      name: x-algolia-application-id
      description: Your Algolia application ID.
    apiKey:
      type: apiKey
      in: header
      name: x-algolia-api-key
      description: >
        Your Algolia API key with the necessary permissions to make the request.

        Permissions are controlled through access control lists (ACL) and access
        restrictions.

        The required ACL to make a request is listed in each endpoint's
        reference.

````